#pragma rtGlobals=1		// Use modern global access method.

#include "C:igormacro:SIS:SIS_core"
// version 2011_06_28

Menu "CLEED"
	"Load PMIN data", CLEED_loadPminData()
	"Load IMP data", CLEED_loadInpData()
	"lattice to INP", CLEED_MakeInput()
	"rescale lattice",CLEED_rescale()
	"Duplicate lattice",CLEED_duplicate()
	"Compare lattices",CLEED_compare()
	"Calc layer properties",  CLEED_interlayerdistance()
	"Build JMOL output", CLEED_outputForJmol()
	"Move by unit vector",CLEED_moveByUnitVector()
end

#pragma rtGlobals=1		// Use modern global access method

Function CLEED_loadInpData()
	NewDataFolder/O/S root:CLEED
	SetDataFolder root:CLEED
	String fileNameStr=""
	Variable refNum	
	Open/R/M="open INP file"/T=".INP" refNum //as fileNameStr
	String str=""
	variable i0=0
	variable i=0
	PauseUpdate
	// if filename different from null continues
	if (stringMatch(S_fileName,"")!=1)
		// print in history
		print "*************************************************************"
		print "loading INP data from: ",S_fileName
     		 // waves
		wave xx=root:CLEED:xx
		wave yy=root:CLEED:yy
		wave zz=root:CLEED:zz
		wave a1=root:CLEED:a1
		wave a2=root:CLEED:a2
		wave m1=root:CLEED:m1
		wave m2=root:CLEED:m2
		wave layerindex=root:CLEED:layerindex
		wave layerheight=root:CLEED:layerheight
		wave layerdistance=root:CLEED:layerdistance
		wave c1=root:CLEED:c1
		wave c2=root:CLEED:c2
		wave/T atomName=root:CLEED:atomName
		// make waves
		make/N=1000/o xx=NaN,yy=NaN,zz=NaN 
		make/N=1000/T/O atomName="" 
		make/N=3/O a1=NaN,a2=NaN
		make/N=2/O m1=NaN,m2=NaN
		variable tmpx,tmpy,tmpz
		String tmpName=""
		String type=""
		// intitialize arrays
		variable k=0
		do	
				FReadLine /T=(num2char(10)) refNum, str	
				str=ReplaceString("\t",str," ")		
				type=CLEED_getTheFirstString(str)
				str=CLEED_skipTheFirstData(str) //skip first:
				if (strsearch(type,"a1:",0)>=0)
					tmpx=CLEED_getTheFirstData(str) // get x coord
					str=CLEED_skipTheFirstData(str) // get the next
					tmpy=CLEED_getTheFirstData(str) // get y coord
					str=CLEED_skipTheFirstData(str) // get the next
					tmpz=CLEED_getTheFirstData(str) // get z coord
					a1[0]=tmpx
					a1[1]=tmpy
					a1[2]=tmpz
					print a1[0],a1[1],a1[2]
				endif
				if (strsearch(type,"a2:",0)>=0)
					tmpx=CLEED_getTheFirstData(str) // get x coord
					str=CLEED_skipTheFirstData(str) // get the next
					tmpy=CLEED_getTheFirstData(str) // get y coord
					str=CLEED_skipTheFirstData(str) // get the next
					tmpz=CLEED_getTheFirstData(str) // get z coord
					a2[0]=tmpx
					a2[1]=tmpy
					a2[2]=tmpz
					print a2[0],a2[1],a2[2]
				endif
				if (strsearch(type,"m1:",0)>=0)
					tmpx=CLEED_getTheFirstData(str) // get x coord
					str=CLEED_skipTheFirstData(str) // get the next
					tmpy=CLEED_getTheFirstData(str) // get y coord
					m1[0]=tmpx
					m1[1]=tmpy
					print m1[0],m1[1]
				endif
				if (strsearch(type,"m2:",0)>=0)
					tmpx=CLEED_getTheFirstData(str) // get x coord
					str=CLEED_skipTheFirstData(str) // get the next
					tmpy=CLEED_getTheFirstData(str) // get y coord
					m2[0]=tmpx
					m2[1]=tmpy
					print m2[0],m2[1]				
				endif
				k+=1
		while (strlen(str)>0 && k<4)
		// calculates unit vectors according to a1,2 and m1,2	
		make/N=3/O c1,c2
		c1[0]=m1[0]*a1[0]+m1[1]*a2[0]
		c1[1]=m1[0]*a1[1]+m1[1]*a2[1]
		c1[2]=0
		c2[0]=m2[0]*a1[0]+m2[1]*a2[0]
		c2[1]=m2[0]*a1[1]+m2[1]*a2[1]
		c2[2]=0	
		// read the rest
		i=0
		// loop
		do
			FReadLine /T=(num2char(10)) refNum, str	
			str=ReplaceString("\t",str," ")
			type=CLEED_getTheFirstString(str)
			str=CLEED_skipTheFirstData(str) //skip po:
			tmpName=CLEED_getAtomName(str) // get atom type
			// print stringmatch(type,"po:"),"*"+type+"*" 
			if (strlen(tmpName)>0 && stringmatch(type,"po: ")==1)
				str=CLEED_skipTheFirstData(str) // get the next
				tmpx=CLEED_getTheFirstData(str) // get x coord
				str=CLEED_skipTheFirstData(str) // get the next
				tmpy=CLEED_getTheFirstData(str) // get y coord
				str=CLEED_skipTheFirstData(str) // get the next
				tmpz=CLEED_getTheFirstData(str) // get z coord
				atomName[i]=tmpName
				xx[i]=tmpx
				yy[i]=tmpy
				zz[i]=tmpz
				print type,i,atomName[i], xx[i],yy[i],zz[i]
				i+=1
			endif
		while (strlen(str)>0)	
		close refnum
		// display waves
		redimension/n=(i) xx,yy,zz,atomName
		SIS_tableToFront("CLEEDoutput","atomName")
		SIS_tableToFront("CLEEDoutput","xx")
		SIS_tableToFront("CLEEDoutput","yy")
		SIS_tableToFront("CLEEDoutput","zz")
		SIS_tableToFront("CLEEDoutput","a1")
		SIS_tableToFront("CLEEDoutput","a2")
		SIS_tableToFront("CLEEDoutput","m1")
		SIS_tableToFront("CLEEDoutput","m2")
		SIS_tableToFront("CLEEDoutput","c1")
		SIS_tableToFront("CLEEDoutput","c2")
	endif
End

Function CLEED_loadPminData()
	NewDataFolder/O/S root:CLEED
	SetDataFolder root:CLEED
	String fileNameStr=""
	Variable refNum	
	String fileFilters = "Data Files (*.PMIN):.PMIN;"
	Open/R/M="open PMIN file"/F=fileFilters refNum // as fileNameStr
	String str=""
	variable i0=0
	variable i=0
	PauseUpdate
	// if filename different from null continues
	if (stringMatch(S_fileName,"")!=1)
		// print in history
		print "*************************************************************"
		print "loading PMIN data from: ",S_fileName
     		 // waves
		wave xx=root:CLEED:xx
		wave yy=root:CLEED:yy
		wave zz=root:CLEED:zz
		wave a1=root:CLEED:a1
		wave a2=root:CLEED:a2
		wave m1=root:CLEED:m1
		wave m2=root:CLEED:m2
		wave layerindex=root:CLEED:layerindex
		wave layerheight=root:CLEED:layerheight
		wave layerdistance=root:CLEED:layerdistance
		wave c1=root:CLEED:c1
		wave c2=root:CLEED:c2
		wave/T atomName=root:CLEED:atomName
		// make waves
		make/N=1000/o xx=NaN,yy=NaN,zz=NaN 
		make/N=1000/T/O atomName="" 
		make/N=3/O a1=NaN,a2=NaN
		make/N=2/O m1=NaN,m2=NaN
		variable tmpx,tmpy,tmpz
		String tmpName=""
		String type=""
		// skip first line
		FReadLine /T=(num2char(10)) refNum, str		// Read all into string variable
		// loop
		do
			FReadLine /T=(num2char(10)) refNum, str	
			str=ReplaceString("\t",str," ")
			type=CLEED_getTheFirstString(str)
			str=CLEED_skipTheFirstData(str) //skip po:
			tmpName=CLEED_getAtomName(str) // get atom type 
			if (strlen(tmpName)>0)
				str=CLEED_skipTheFirstData(str) // get the next
				tmpx=CLEED_getTheFirstData(str) // get x coord
				str=CLEED_skipTheFirstData(str) // get the next
				tmpy=CLEED_getTheFirstData(str) // get y coord
				str=CLEED_skipTheFirstData(str) // get the next
				tmpz=CLEED_getTheFirstData(str) // get z coord
				atomName[i]=tmpName
				xx[i]=tmpx
				yy[i]=tmpy
				zz[i]=tmpz
				print i,atomName[i], xx[i],yy[i],zz[i]
				i+=1
			endif
		while (strlen(str)>0)	
		close refnum
		Open/R/M="open INP file"/T=".INP" refNum //as fileNameStr
		print "loading PMIN data from: ",S_fileName
		if (stringMatch(S_fileName,"")!=1)
			variable k=0
			do	
				FReadLine /T=(num2char(10)) refNum, str	
				str=ReplaceString("\t",str," ")		
				type=CLEED_getTheFirstString(str)
				str=CLEED_skipTheFirstData(str) //skip first:
				if (strsearch(type,"a1:",0)>=0)
					tmpx=CLEED_getTheFirstData(str) // get x coord
					str=CLEED_skipTheFirstData(str) // get the next
					tmpy=CLEED_getTheFirstData(str) // get y coord
					str=CLEED_skipTheFirstData(str) // get the next
					tmpz=CLEED_getTheFirstData(str) // get z coord
					a1[0]=tmpx
					a1[1]=tmpy
					a1[2]=tmpz
					print a1[0],a1[1],a1[2]
				endif
				if (strsearch(type,"a2:",0)>=0)
					tmpx=CLEED_getTheFirstData(str) // get x coord
					str=CLEED_skipTheFirstData(str) // get the next
					tmpy=CLEED_getTheFirstData(str) // get y coord
					str=CLEED_skipTheFirstData(str) // get the next
					tmpz=CLEED_getTheFirstData(str) // get z coord
					a2[0]=tmpx
					a2[1]=tmpy
					a2[2]=tmpz
					print a2[0],a2[1],a2[2]
				endif
				if (strsearch(type,"m1:",0)>=0)
					tmpx=CLEED_getTheFirstData(str) // get x coord
					str=CLEED_skipTheFirstData(str) // get the next
					tmpy=CLEED_getTheFirstData(str) // get y coord
					m1[0]=tmpx
					m1[1]=tmpy
					print m1[0],m1[1]
				endif
				if (strsearch(type,"m2:",0)>=0)
					tmpx=CLEED_getTheFirstData(str) // get x coord
					str=CLEED_skipTheFirstData(str) // get the next
					tmpy=CLEED_getTheFirstData(str) // get y coord
					m2[0]=tmpx
					m2[1]=tmpy
					print m2[0],m2[1]				
				endif
				k+=1
			while (strlen(str)>0 && k<4)
			// calculates unit vectors according to a1,2 and m1,2	
			make/N=3/O c1,c2
			c1[0]=m1[0]*a1[0]+m1[1]*a2[0]
			c1[1]=m1[0]*a1[1]+m1[1]*a2[1]
			c1[2]=0
			c2[0]=m2[0]*a1[0]+m2[1]*a2[0]
			c2[1]=m2[0]*a1[1]+m2[1]*a2[1]
			c2[2]=0	
		endif
		// display waves
		redimension/n=(i) xx,yy,zz,atomName
		SIS_tableToFront("CLEEDoutput","atomName")
		SIS_tableToFront("CLEEDoutput","xx")
		SIS_tableToFront("CLEEDoutput","yy")
		SIS_tableToFront("CLEEDoutput","zz")
		SIS_tableToFront("CLEEDoutput","a1")
		SIS_tableToFront("CLEEDoutput","a2")
		SIS_tableToFront("CLEEDoutput","m1")
		SIS_tableToFront("CLEEDoutput","m2")
		SIS_tableToFront("CLEEDoutput","c1")
		SIS_tableToFront("CLEEDoutput","c2")
	endif
End

Function CLEED_MakeInput()
	NewDataFolder/O/S root:CLEED
	SetDataFolder root:CLEED
	String fileNameStr=""
	Variable refNum	
	Open/R/M="open INP file"/T=".INP" refNum //as fileNameStr
	String str=""
	variable i0=0
	variable i=0
	PauseUpdate
	// if filename different from null continues
	if (stringMatch(S_fileName,"")!=1)
		// print in history
		print "*************************************************************"
		print "mimicing INP data from: ",S_fileName
		print "*************************************************************"
		variable scaling=1
		prompt scaling, "Rescaling factor"
		doPrompt "input", scaling
     		 // waves
		wave xx=root:CLEED:xx
		wave yy=root:CLEED:yy
		wave zz=root:CLEED:zz
		wave a1=root:CLEED:a1
		wave a2=root:CLEED:a2
		wave m1=root:CLEED:m1
		wave m2=root:CLEED:m2
		wave layerindex=root:CLEED:layerindex
		wave layerheight=root:CLEED:layerheight
		wave layerdistance=root:CLEED:layerdistance
		wave c1=root:CLEED:c1
		wave c2=root:CLEED:c2
		wave/T atomName=root:CLEED:atomName
		//
		variable k=0
		string tmp,tmp1,tmp2,tmp3,tmp4,tmp5,tmp6
		variable xk,yk,zk
		do	
			FReadLine /T=(num2char(10)) refNum, str
			str=ReplaceString("\t",str," ")
			if (strsearch(str,"a1:",0)>=0)
				printf "a1:\t%f\t%f\t%f\r",a1[0]*scaling,a1[1]*scaling,a1[2]*scaling
			endif
			if (strsearch(str,"a2:",0)>=0)
				printf "a2:\t%f\t%f\t%f\r",a2[0]*scaling,a2[1]*scaling,a2[2]*scaling
			endif
			if (strsearch(str,"m1:",0)>=0)
				print "m1:\t"+num2iStr(m1[0])+".\t"+num2iStr(m1[1])+".\r"
			endif
			if (strsearch(str,"m2:",0)>=0)
				print "m2:\t"+num2iStr(m2[0])+".\t"+num2iStr(m2[1])+".\r"
			endif
			if ((strsearch(str,"#",0)>=0) || (strsearch(str,"spp",0)>=0) || (strsearch(str,"spn",0)>=0) || (strsearch(str,"rm",0)>=0) || (strsearch(str,"zr",0)>=0) || (strsearch(str,"sr",0)>=0) || (strsearch(str,"sa",0)>=0) )
				str=str[0,strlen(str)-2]
				print str
			endif
			if (strsearch(str,"po:",0)>=0)
				xk=xx[k]*scaling
				yk=yy[k]*scaling
				zk=zz[k]*scaling
				tmp1=CLEED_getTheFirstString(str)
				str=CLEED_skipTheFirstData(str)  // get the next
				tmp2=CLEED_getTheFirstString(str)
				str=CLEED_skipTheFirstData(str)  // get the next
				tmp=CLEED_getTheFirstString(str)
				str=CLEED_skipTheFirstData(str) 
				tmp=CLEED_getTheFirstString(str)
				str=CLEED_skipTheFirstData(str) 
				tmp=CLEED_getTheFirstString(str)
				str=CLEED_skipTheFirstData(str) 
				tmp3=CLEED_getTheFirstString(str)
				tmp4=CLEED_skipTheFirstData(str) 
				tmp4=tmp4[0,strlen(tmp4)-2]
				printf "%s\t%s\t%f\t%f\t%f\t%s\t%s%s",tmp1,tmp2,xk,yk,zk,tmp3,tmp4,"\r"
				// print tmp1+"\t"+tmp2+"\t"+num2str(xk)+"\t"+num2str(yk)+"\t"+num2str(zk)+"\t"+tmp3+"\t"+tmp4
				k+=1
			endif
		while (strlen(str)>0)
		close refnum
	endif
end

Function CLEED_rescale()
		variable scaling=1
		prompt scaling, "Rescaling factor"
		doPrompt "input", scaling
     		 // waves
		wave xx=root:CLEED:xx
		wave yy=root:CLEED:yy
		wave zz=root:CLEED:zz
		wave a1=root:CLEED:a1
		wave a2=root:CLEED:a2
		wave c1=root:CLEED:c1
		wave c2=root:CLEED:c2
		xx*=scaling
		yy*=scaling
		zz*=scaling
		a1*=scaling
		a2*=scaling
		c1*=scaling
		c2*=scaling
End

Function CLEED_duplicate()
		String  tablestr="reference"
		Prompt tablestr, "new name"
		DoPrompt "enter table name", tablestr
		duplicate/o xx xx1
		duplicate/o yy yy1
		duplicate/o zz zz1
		SIS_tableToFront(tablestr,"atomName")
		SIS_tableToFront(tablestr,"xx1")
		SIS_tableToFront(tablestr,"yy1")
		SIS_tableToFront(tablestr,"zz1")
		SIS_tableToFront(tablestr,"a1")
		SIS_tableToFront(tablestr,"a2")
		SIS_tableToFront(tablestr,"m1")
		SIS_tableToFront(tablestr,"m2")
		SIS_tableToFront(tablestr,"c1")
		SIS_tableToFront(tablestr,"c2")
End

Function CLEED_compare()
		wave xx,xx1
		wave yy,yy1
		wave zz,zz1
		duplicate/o xx cxx
		duplicate/o yy cyy
		duplicate/o zz czz
		duplicate/o cxx crr
		string tablestr="compare"
		cxx=xx-xx1
		cyy=yy-yy1
		czz=zz-zz1	
		crr=sqrt(cxx^2+cyy^2+czz^2)
		SIS_tableToFront(tablestr,"atomName")
		SIS_tableToFront(tablestr,"crr")
		SIS_tableToFront(tablestr,"cxx")
		SIS_tableToFront(tablestr,"cyy")
		SIS_tableToFront(tablestr,"czz")
		SIS_tableToFront(tablestr,"xx")
		SIS_tableToFront(tablestr,"xx1")
		SIS_tableToFront(tablestr,"yy")
		SIS_tableToFront(tablestr,"yy1")
		SIS_tableToFront(tablestr,"zz")
		SIS_tableToFront(tablestr,"zz1")
		// 
		SIS_waveToFront("diffgraph","cxx")
		SIS_waveToFront("diffgraph","cyy")
		SIS_waveToFront("diffgraph","czz")
		SIS_waveToFront("diffgraph","crr")
		CLEED_Graph_Style()
		ModifyGraph mode(cxx)=4,marker(cxx)=8,rgb(cxx)=(65280,0,0),mode(cyy)=4;DelayUpdate
		ModifyGraph marker(cyy)=8,rgb(cyy)=(0,39168,0),marker(czz)=8;DelayUpdate
		ModifyGraph rgb(czz)=(0,15872,65280),mode(crr)=4,marker(crr)=19,rgb(crr)=(0,0,0)
		ModifyGraph marker(cxx)=19,marker(cyy)=19,marker(czz)=19,marker(crr)=2
		ModifyGraph mode=4
		Legend/C/N=text0/J/A=RT "\\s(cxx) delta x\r\\s(cyy) delta y\r\\s(czz) delta z\r\\s(crr) delta r"
		ModifyGraph width=453.543,height={Aspect,0.5}
		// print sdev
		String labelStr,textStr
		variable nlayers=1
		variable i=0,j=0
		variable nmax=dimsize(xx,0)
		// counts layers
		do
			if (abs(zz[j]-zz[j-1])>1)
				nlayers+=1
			endif
			j+=1
		while(j<nmax)
		variable j0=nmax-1
		j=nmax-1
		for (i=nlayers-1; i>=0; i-=1)
			do
				j-=1
			while(abs(zz[j+1]-zz[j])<1.0 && j>=0)
			Wavestats/Q /W /R=(j+1,j0) crr
	     		 labelStr=""
			textStr="text"+num2str(i+1)
			labelStr = "layer no. "+num2str(i+1)+"rms distance= "+num2Str(V_sdev)
			Tag/C/N=$textStr/B=1 crr, (j+1), labelStr 
	      		// next loop
			j0=j
	endfor
	Tag/C/N=text1/X=20.00/Y=32.00 
	Tag/C/N=text2/X=16.00/Y=26.00 
	Tag/C/N=text3/X=8.00/Y=-50.00
End

Function CLEED_interlayerdistance()
	SetDataFolder root:CLEED
	print "*************************************************************"
	print "CLEED interlayer distance: "
	print "*************************************************************"
     	// waves
	wave xx=root:CLEED:xx
	wave yy=root:CLEED:yy
	wave zz=root:CLEED:zz
	wave a1=root:CLEED:a1
	wave a2=root:CLEED:a2
	wave m1=root:CLEED:m1
	wave m2=root:CLEED:m2
	wave layerindex=root:CLEED:layerindex
	wave layerheight=root:CLEED:layerheight
	wave layerdistance=root:CLEED:layerdistance
	wave c1=root:CLEED:c1
	wave c2=root:CLEED:c2
	wave maxh=root:CLEED:maxh
	wave minh=root:CLEED:minh
	wave sdevw=root:CLEED:sdevw
	wave/T atomName=root:CLEED:atomName
	//
	variable z0=zz[0]
	variable j=1
	variable tmp=0
	variable nmax=dimsize(xx,0)	
	variable nlayers=1
	SIS_graphToFront("z_vs_x","zz","xx")
	ModifyGraph mode=3,marker=19
	Label left "\\F'Arial'\\Z16distance along z ()";DelayUpdate
	Label bottom "\\F'Arial'\\Z16distance along unit vector a1 ()"
	SetAxis left 0,10
	ModifyGraph width=320,height=240
	// counts layers
	do
		if (abs(zz[j]-zz[j-1])>1)
			nlayers+=1
		endif
		j+=1
	while(j<nmax)
	j=0
	// create waves with nlayers
	make/N=(nlayers)/o layerheight,layerdistance,layerindex,maxh,minh,sdevw
	variable height
	string tmpStr=""
	string textStr=""
	variable i=0
	variable j0=nmax-1
	j=nmax-1
	variable height0=0
	variable thisheight
	String labelStr
	for (i=nlayers-1; i>=0; i-=1)
		do
			j-=1
		while(abs(zz[j+1]-zz[j])<1.0 && j>=0)
		Wavestats/Q /W /R=(j+1,j0) zz	
		layerheight[i]=V_avg
	      thisheight=layerheight[i]
	      layerdistance[i]=thisheight-height0
		layerindex[i]=i+1	
	 	maxh[i]=V_max-thisheight
		minh[i]=V_min-thisheight
		sdevw[i]=V_sdev
	      // debug print layerindex[i], j+1,j0,layerheight[i], layerdistance[i], minh[i], maxh[i]
	      labelStr=""
		textStr="text"+num2str(i+1)
		labelStr = "layer no. "+num2str(i+1)+" distance= "+num2Str(layerdistance[i])+"\r"
		labelStr+="min = "+num2Str(minh[i])+" max = "+num2Str(maxh[i])+" delta = "+num2Str(abs(maxh[i]-minh[i]))+"\r"
		labelStr+="sdev = "+num2Str(sdevw[i])
		Tag/C/N=$textStr zz, (j+1), labelStr 
	      // next loop
		j0=j
		height0=layerheight[i]
	endfor	
	SIS_tableToFront("CLEEDoutput","layerheight")
	SIS_tableToFront("CLEEDoutput","layerdistance")
	SIS_tableToFront("CLEEDoutput","maxh")
	SIS_tableToFront("CLEEDoutput","minh")
	SIS_tableToFront("CLEEDoutput","sdevw")
end

Function CLEED_outputForJmol()
      SetDataFolder root:CLEED
	// waves
	wave xx=root:CLEED:xx
	wave yy=root:CLEED:yy
	wave zz=root:CLEED:zz
	wave a1=root:CLEED:a1
	wave a2=root:CLEED:a2
	wave m1=root:CLEED:m1
	wave m2=root:CLEED:m2
	wave layerindex=root:CLEED:layerindex
	wave layerheight=root:CLEED:layerheight
	wave layerdistance=root:CLEED:layerdistance
	wave c1=root:CLEED:c1
	wave c2=root:CLEED:c2
	wave/T atomName=root:CLEED:atomName
	// input
	variable len=dimsize(xx,0)-1	
	variable uc1=1	
	Prompt uc1, "no. unit vectors c1"	
	variable uc2=8
	Prompt uc2, "no. unit vectors c2"
	variable depth=len
	Prompt depth, "depth (last atom index)"
	DoPrompt "build JMOL output", uc1,uc2,depth
	if (V_flag==0)
		String fileNameStr
		Variable refNum	
		String fileFilter = "Data Files (*.xyz):.xyz;"
		Open/M="write XYZ file"/F=fileFilter refNum //as fileNameStr
		print "*************************************************************"	
		String lineStr=""
		variable nmax=depth
		print "CLEEDoutput to jmol: ",S_filename, "depth:", nmax
		lineStr=num2Str((depth+1)*uc2*uc1)+"\r"
		fprintf refnum, lineStr
		lineStr="unit cell: "+"\r"
		fprintf refnum, lineStr
		variable xi,yi,zi
		variable i,j,k
		// now every other vector is written as n1*C1+n2*C2+xx,yy,zz
		i=0
		do
			j=0
			do
				k=0
				do
					xi=i*c1[0]+j*c2[0]+xx(k)
					yi=i*c1[1]+j*c2[1]+yy(k)
					zi=i*c1[2]+j*c2[2]+zz(k)
					fprintf refnum," %s %g %g %g \r",atomName(k),xi,yi,zi
					k+=1
				while(k<=nmax)
				j+=1
			while(j<uc2)
			i+=1
		while(i<uc1)
		close refnum
	endif
end

Function CLEED_moveByUnitVector()
	SetDataFolder root:CLEED
	variable index=0
	Prompt index, "atom no."	
	variable vectorc=1
	Prompt vectorc, "cell vector", popup "c1;c2;-c1;-c2;"		
	DoPrompt "move by cell vector input", index,vectorc
	If (V_flag==0)
		CLEED_translateByVector(index,vectorc)
	endif
end 

Function CLEED_translateByVector(index,vectorc)
	variable index,vectorc	
	// waves
	wave xx=root:CLEED:xx
	wave yy=root:CLEED:yy
	wave zz=root:CLEED:zz
	wave a1=root:CLEED:a1
	wave a2=root:CLEED:a2
	wave m1=root:CLEED:m1
	wave m2=root:CLEED:m2
	wave layerindex=root:CLEED:layerindex
	wave layerheight=root:CLEED:layerheight
	wave layerdistance=root:CLEED:layerdistance
	wave c1=root:CLEED:c1
	wave c2=root:CLEED:c2
	wave/T atomName=root:CLEED:atomName
	// move
	if (vectorc==1)
		xx[index]+=c1[0]	
		yy[index]+=c1[1]	
	endif
	if (vectorc==2)
		xx[index]+=c2[0]	
		yy[index]+=c2[1]	
	endif
	if (vectorc==3)
		xx[index]-=c1[0]	
		yy[index]-=c1[1]	
	endif
	if (vectorc==4)
		xx[index]-=c2[0]	
		yy[index]-=c2[1]	
	endif
end

Function CLEED_newOrigin(index)
	variable index
	variable ox,oy	
	// waves
	wave xx=root:CLEED:xx
	wave yy=root:CLEED:yy
	wave zz=root:CLEED:zz
	wave a1=root:CLEED:a1
	wave a2=root:CLEED:a2
	wave m1=root:CLEED:m1
	wave m2=root:CLEED:m2
	wave layerindex=root:CLEED:layerindex
	wave layerheight=root:CLEED:layerheight
	wave layerdistance=root:CLEED:layerdistance
	wave c1=root:CLEED:c1
	wave c2=root:CLEED:c2
	wave/T atomName=root:CLEED:atomName
	// move
	ox=xx[index]
	oy=yy[index]
	xx-=ox
	yy-=oy	
end

Function CLEED_TranslateByXY(tx,ty)
	variable tx,ty	
	// waves
	wave xx=root:CLEED:xx
	wave yy=root:CLEED:yy
	wave zz=root:CLEED:zz
	wave a1=root:CLEED:a1
	wave a2=root:CLEED:a2
	wave m1=root:CLEED:m1
	wave m2=root:CLEED:m2
	wave layerindex=root:CLEED:layerindex
	wave layerheight=root:CLEED:layerheight
	wave layerdistance=root:CLEED:layerdistance
	wave c1=root:CLEED:c1
	wave c2=root:CLEED:c2
	wave/T atomName=root:CLEED:atomName
	// move
	xx-=tx
	yy-=ty	
end

Function CLEED_swap(index1,index2)
	variable index1,index2
	variable tmpx,tmpy,tmpz
	// waves
	wave xx=root:CLEED:xx
	wave yy=root:CLEED:yy
	wave zz=root:CLEED:zz
      tmpx=xx[index1]	
      tmpy=yy[index1]
      tmpz=zz[index1]
      xx[index1]=xx[index2]
      yy[index1]=yy[index2]
      zz[index1]=zz[index2]
      xx[index2]=tmpx
      yy[index2]=tmpy
      zz[index2]=tmpz
end	

Function/S CLEED_skipTheFirstData(str)
	string str
	variable i0
	i0=strsearch(str," ",0)
	str=str[i0+1,strlen(str)]
	do 
		if (strsearch(str," ",0)==0)
			str=str[1,strlen(str)]
		endif
	while(strsearch(str," ",0)==0)
	return str
end

Function/S CLEED_getAtomName(str)
	string str
	variable i0
	i0=strsearch(str,"_",0)
	str=str[0,i0-1]
	return str
end

Function/S CLEED_getTheFirstString(str)
	string str
	variable i0
	i0=strsearch(str," ",0)
	str=str[0,i0]
	return str
end

Function CLEED_getTheFirstData(str)
	string str
	variable i0
	i0=strsearch(str," ",0)
	if (i0 >= 0)
		str=str[0,i0]
	else
		str=str[0,strlen(str)]
	endif
	return str2num(str)
end

Function CLEED_Graph_Style()
	Label left "\\F'Arial'\\Z16Distance ()";DelayUpdate
	Label bottom "\\F'Arial'\\Z16Atom number"
	ModifyGraph mode=4,marker=19
	ModifyGraph fSize=14
	ModifyGraph mirror=1
	SetAxis left -0.5,0.5
	ModifyGraph width=283.465,height={Aspect,0.75}
end

Macro Prepare_Natasa_1x8() 
	CLEED_translateByVector(5,2); 
	CLEED_translateByVector(6,2); 
	CLEED_translateByVector(2,2); 
	CLEED_translateByVector(7,2); 
	CLEED_translateByVector(7,2); 
	CLEED_translateByVector(3,2); 
	CLEED_translateByVector(3,2); 
	CLEED_translateByVector(8,2); 
	CLEED_translateByVector(8,2); 
	CLEED_translateByVector(8,2); 
	CLEED_translateByVector(4,2); 
	CLEED_translateByVector(4,2); 
	CLEED_translateByVector(4,2); 
	CLEED_translateByVector(9,2); 
	CLEED_translateByVector(9,2); 
	CLEED_translateByVector(9,2); 
	CLEED_translateByVector(9,2);
	CLEED_translateByVector(0,1); 
	CLEED_translateByVector(5,1);
	// FIRST LAYER 
	CLEED_translateByVector(10,1); 
	CLEED_translateByVector(11,2); 
	CLEED_translateByVector(15,2); 
	CLEED_translateByVector(12,2); 
	CLEED_translateByVector(12,2); 
	CLEED_translateByVector(16,2); 
	CLEED_translateByVector(16,2);
	CLEED_translateByVector(13,2); 
	CLEED_translateByVector(13,2); 
	CLEED_translateByVector(13,2); 
	CLEED_translateByVector(17,2);
	CLEED_translateByVector(17,2); 
	CLEED_translateByVector(17,2); 
	// SECOND LAYER
	CLEED_translateByVector(18,1); 
	CLEED_translateByVector(22,2);
	CLEED_translateByVector(19,2); 
	CLEED_translateByVector(23,2); 
	CLEED_translateByVector(23,2);
	CLEED_translateByVector(20,2); 
	CLEED_translateByVector(20,2);    
	CLEED_translateByVector(24,2); 
	CLEED_translateByVector(24,2);
	CLEED_translateByVector(24,2); 
	CLEED_translateByVector(21,2); 
	CLEED_translateByVector(21,2);
	CLEED_translateByVector(21,2);
	CLEED_translateByVector(25,2); 
	CLEED_translateByVector(25,2); 
	CLEED_translateByVector(25,2);
	CLEED_translateByVector(25,2); 
	//fix origin
	CLEED_TranslateByXY(a1[0],a1[1])
	//swap
	CLEED_swap(1,0)
	CLEED_swap(1,6)
	CLEED_swap(3,7)
	CLEED_swap(4,7)
	CLEED_swap(5,8)
	CLEED_swap(6,7)
	CLEED_swap(7,9)
	CLEED_swap(8,9)
	CLEED_swap(10,14)
	CLEED_swap(12,15)
	CLEED_swap(13,15)
	CLEED_swap(14,16)
	CLEED_swap(16,17)
	CLEED_swap(18,22)
	CLEED_swap(20,23)
	CLEED_swap(21,23)
	CLEED_swap(22,24)
	CLEED_swap(24,25)
end

Macro Prepare_Natasa_1x8b() 
	CLEED_translateByVector(5,2); 
	CLEED_translateByVector(6,2); 
	CLEED_translateByVector(2,2); 
	CLEED_translateByVector(7,2); 
	CLEED_translateByVector(7,2); 
	CLEED_translateByVector(3,2); 
	CLEED_translateByVector(3,2); 
	CLEED_translateByVector(8,2); 
	CLEED_translateByVector(8,2); 
	CLEED_translateByVector(8,2); 
	CLEED_translateByVector(4,2); 
	CLEED_translateByVector(4,2); 
	CLEED_translateByVector(4,2); 
	CLEED_translateByVector(9,2); 
	CLEED_translateByVector(9,2); 
	CLEED_translateByVector(9,2); 
	CLEED_translateByVector(9,2);
	CLEED_translateByVector(0,1); 
	CLEED_translateByVector(5,4);
	// FIRST LAYER 
	CLEED_translateByVector(11,2); 
	CLEED_translateByVector(15,2); 
	CLEED_translateByVector(12,2); 
	CLEED_translateByVector(12,2); 
	CLEED_translateByVector(16,2); 
	CLEED_translateByVector(16,2);
	CLEED_translateByVector(13,2); 
	CLEED_translateByVector(13,2); 
	CLEED_translateByVector(13,2); 
	CLEED_translateByVector(17,2);
	CLEED_translateByVector(17,2); 
	CLEED_translateByVector(17,2); 
	// SECOND LAYER
	CLEED_translateByVector(22,2);
	CLEED_translateByVector(19,2); 
	CLEED_translateByVector(23,2); 
	CLEED_translateByVector(23,2);
	CLEED_translateByVector(20,2); 
	CLEED_translateByVector(20,2);    
	CLEED_translateByVector(24,2); 
	CLEED_translateByVector(24,2);
	CLEED_translateByVector(24,2); 
	CLEED_translateByVector(21,2); 
	CLEED_translateByVector(21,2);
	CLEED_translateByVector(21,2);
	CLEED_translateByVector(25,2); 
	CLEED_translateByVector(25,2); 
	CLEED_translateByVector(25,2);
	CLEED_translateByVector(25,2); 
	//swap
	CLEED_swap(0,5)
	CLEED_swap(2,6)
	CLEED_swap(3,6)
	CLEED_swap(4,7)
	CLEED_swap(5,6)
	CLEED_swap(6,8)
	CLEED_swap(8,9)
	CLEED_swap(11,14)
	CLEED_swap(12,14)
	CLEED_swap(13,15)
	CLEED_swap(15,16)
	CLEED_swap(19,22)
	CLEED_swap(20,22)
	CLEED_swap(21,23)
	CLEED_swap(23,24)
end

Macro Prepare_Natasa_1x7()
	CLEED_translateByVector(0,1); 
	CLEED_translateByVector(1,1); 
	CLEED_translateByVector(2,1); 
	CLEED_translateByVector(3,1); 
	CLEED_translateByVector(3,2); 
	CLEED_translateByVector(4,1)
	CLEED_translateByVector(5,4)
	CLEED_translateByVector(9,1)
	CLEED_translateByVector(10,1)
	CLEED_translateByVector(11,1)
	CLEED_translateByVector(16,1)
	CLEED_translateByVector(17,1)
	CLEED_translateByVector(18,1)
	CLEED_TranslateByXY(a1[0]*3,a1[1]*3)
	CLEED_swap(0,5)
	CLEED_swap(1,6)
	CLEED_swap(2,7)
	CLEED_swap(3,8)
	CLEED_swap(4,5)
	CLEED_swap(5,6)
	CLEED_swap(6,7)
	CLEED_swap(9,12)
	CLEED_swap(10,13)
	CLEED_swap(11,14)
	CLEED_swap(12,15)
	CLEED_swap(13,15)
	CLEED_swap(14,15)
	CLEED_swap(16,19)
	CLEED_swap(17,20)
	CLEED_swap(18,21)
	CLEED_swap(19,22)
	CLEED_swap(20,22)
	CLEED_swap(21,22)
end

Macro Shift_Natasa_1x7()
	CLEED_translateByVector(0,1); 
	CLEED_translateByVector(0,2); 
	CLEED_translateByVector(9,1); 
	CLEED_translateByVector(16,1); 
	// top
	CLEED_swap(0,1)
	CLEED_swap(1,2)
	CLEED_swap(2,3)
	CLEED_swap(3,4)
	CLEED_swap(4,5)
	CLEED_swap(5,6)
	CLEED_swap(6,7)
	CLEED_swap(7,8)
	// 1st
	CLEED_swap(9,10)
	CLEED_swap(10,11)
	CLEED_swap(11,12)
	CLEED_swap(12,13)
	CLEED_swap(13,14)
	CLEED_swap(14,15)
	//  2nd
	CLEED_swap(16,17)
	CLEED_swap(17,18)
	CLEED_swap(18,19)
	CLEED_swap(19,20)
	CLEED_swap(20,21)
	CLEED_swap(21,22)
	// 
	CLEED_TranslateByXY(a1[0],a1[1])
End

Macro Prepare_Jacopo_1x8() 
	CLEED_translateByVector(5,2); 
	CLEED_translateByVector(6,2); 
	CLEED_translateByVector(2,2); 
	CLEED_translateByVector(7,2); 
	CLEED_translateByVector(7,2); 
	CLEED_translateByVector(3,2); 
	CLEED_translateByVector(3,2); 
	CLEED_translateByVector(8,2); 
	CLEED_translateByVector(8,2); 
	CLEED_translateByVector(8,2); 
	CLEED_translateByVector(4,2); 
	CLEED_translateByVector(4,2); 
	CLEED_translateByVector(4,2); 
	CLEED_translateByVector(9,2); 
	CLEED_translateByVector(9,2); 
	CLEED_translateByVector(9,2); 
	CLEED_translateByVector(9,2);
	CLEED_translateByVector(0,1); 
	CLEED_translateByVector(5,1);
	// FIRST LAYER 
	CLEED_translateByVector(10,1); 
	CLEED_translateByVector(11,2); 
	CLEED_translateByVector(15,2); 
	CLEED_translateByVector(12,2); 
	CLEED_translateByVector(12,2); 
	CLEED_translateByVector(16,2); 
	CLEED_translateByVector(16,2);
	CLEED_translateByVector(13,2); 
	CLEED_translateByVector(13,2); 
	CLEED_translateByVector(13,2); 
	CLEED_translateByVector(17,2);
	CLEED_translateByVector(17,2); 
	CLEED_translateByVector(17,2); 
	// SECOND LAYER
	CLEED_translateByVector(18,1); 
	CLEED_translateByVector(22,2);
	CLEED_translateByVector(19,2); 
	CLEED_translateByVector(23,2); 
	CLEED_translateByVector(23,2);
	CLEED_translateByVector(20,2); 
	CLEED_translateByVector(20,2);    
	CLEED_translateByVector(24,2); 
	CLEED_translateByVector(24,2);
	CLEED_translateByVector(24,2); 
	CLEED_translateByVector(21,2); 
	CLEED_translateByVector(21,2);
	CLEED_translateByVector(21,2);
	CLEED_translateByVector(25,2); 
	CLEED_translateByVector(25,2); 
	CLEED_translateByVector(25,2);
	CLEED_translateByVector(25,2); 
	//swap
	CLEED_swap(1,0)
	CLEED_swap(1,6)
	CLEED_swap(3,7)
	CLEED_swap(4,7)
	CLEED_swap(5,8)
	CLEED_swap(6,7)
	CLEED_swap(7,9)
	CLEED_swap(8,9)
	CLEED_swap(10,14)
	CLEED_swap(12,15)
	CLEED_swap(13,15)
	CLEED_swap(14,16)
	CLEED_swap(16,17)
	CLEED_swap(18,22)
	CLEED_swap(20,23)
	CLEED_swap(21,23)
	CLEED_swap(22,24)
	CLEED_swap(24,25)
	CLEED_newOrigin(18)
	CLEED_TranslateByXY(-a1[0],0)
end

