#pragma rtGlobals=1		// Use modern global access method.

// version 2011_05_04
//  window name: twoletters+datafoldername, in this way the datafolder is always identified unambiguously
//	"MD" for XMC(L)D image
// wave name: image stack as datafolder, single image as image

Menu "XMC(L)D"
	"Process_MD_Data", SIS_MagneticDichroism()
	"Process_MD_Movie", XMCD_MD_Movie()
	"Toggle", XMCD_toggle()
end

Function SIS_MagneticDichroism()
	String ctrlname
	// data folder and stack
	String dfStr=SIS_getDataFolderName()
	SetDataFolder root:$(dfStr)
	String stackStr=SIS_getImageStackName()
	wave wstack=$stackStr
	variable np=dimSize(wstack,0)
	variable nq=dimSize(wstack,1)
	variable nr=dimSize(wstack,2)
	make/n=(np,nq)/o wminus,wplus,wxmcd
	String phase1Str="phase1_"+dfStr[strlen(dfStr)-3,strlen(dfStr)]
	String phase2Str="phase2_"+dfStr[strlen(dfStr)-3,strlen(dfStr)]
	String xmcdStr=stackStr+"_XMCD"
	wave wph1=$phase1Str
	wave wph2=$phase2Str
	wave wph=$phase1Str
	wph=(wph1+wph2)/2
	if (exists(phase1Str)&&exists(phase2Str))
		if (wph[0]>0.1)
			DCR_coadd(wstack,wplus,0,nr/2-1)
			DCR_coadd(wstack,wminus,nr/2,nr-1)
		endif
		if (wph[0]<-0.1)
			DCR_coadd(wstack,wminus,0,nr/2-1)
			DCR_coadd(wstack,wplus,nr/2,nr-1)
		endif
	else
		DCR_coadd(wstack,wminus,0,nr/2-1)
		DCR_coadd(wstack,wplus,nr/2,nr-1)
	endif
	Variable mode=2
	Prompt mode, "Function type", popup "XMLD division (m)/(p);XMCD (m-p)/(m+p);"
	doPrompt "inputXMCD",mode
	if (V_flag==0)
		wavestats/Q wminus
		variable V_avg_minus=V_avg
		wavestats/Q wplus
		variable V_avg_plus=V_avg
		wminus*=(V_avg_plus/V_avg_minus)
		if (mode==1)
			wxmcd=wminus/wplus
			duplicate/o wxmcd $xmcdStr
			SIS_imageToFront("MD"+dfStr,xmcdStr) 
			ModifyImage $xmcdStr ctab= {0.95,1.05,Grays,0}
		endif
		if (mode==2)
			wxmcd=(wminus-wplus)/(wminus+wplus)
			duplicate/o wxmcd $xmcdStr
			SIS_imageToFront("MD"+dfStr,xmcdStr) 
			ModifyImage $xmcdStr ctab= {-0.25,0.25,Grays,0}
		endif
		XMCD_ImageControls()
	endif
	killwaves wminus,wplus,wxmcd
End

Function XMCD_MD_Movie()
	// data folder
	String dfStr=SIS_getDataFolderName()
	SetDataFolder root:$(dfStr)
	// stack
	String stackStr=SIS_getImageStackName()
	wave wstack=$stackStr
	variable nr=dimSize($stackStr,2)
	//redimension/S wstack
	// operation
	variable operation=2
	Prompt operation, "operation:", popup "division;xmcd;"
	variable mode=1
	Prompt mode, "step:", popup "next;previous"
	variable bkg=2
	Prompt bkg, "remove background", popup "no;yes"
	variable order=1
	Prompt order, "Polynomial order:", popup "1;2;3;"
	doPrompt "modify stack" operation,mode,bkg,order
	if ((V_flag==0)&&(nr>1))
		variable i=0
		Redimension/S $stackStr
		duplicate/o M_RoiMask M_layoutMask
		M_layoutMask-=1
		if (operation==1) // division
			// frame i=[i]/[i-(+)1]
			// next: 0/1,0/1,2/3 .. previous:1/0,1/0;3/2
			for (i=0;i<nr;i+=2)
				ImageTransform/P=(i)/PTYP=0 getPlane $stackStr
				duplicate/o M_ImagePlane wprev
				ImageTransform/P=(i+1)/PTYP=0 getPlane $stackStr
				duplicate/o M_ImagePlane wtmp
				if (mode==1)
					wtmp=1000*wtmp/(wprev)
					// remove bkg
					if ((bkg==2)&&(exists("M_layoutMask")))
						ImageStats/R=M_ROIMask wprev
						ImageRemoveBackground/R=M_layoutMask/O/P=(order) wtmp
						wprev+=V_avg
					endif
					ImageTransform/P=(i)/PTYP=0/D=wtmp setPlane $stackStr
					ImageTransform/P=(i+1)/PTYP=0/D=wtmp setPlane $stackStr
				else
					wtmp=1000*wprev/(wtmp)
					// remove bkg
					if ((bkg==2)&&(exists("M_layoutMask")))
						ImageStats/R=M_ROIMask wtmp
						ImageRemoveBackground/R=M_layoutMask/O/P=(order) wtmp
						wtmp+=V_avg
					endif
					ImageTransform/P=(i)/PTYP=0/D=wtmp setPlane $stackStr
					ImageTransform/P=(i+1)/PTYP=0/D=wtmp setPlane $stackStr
				endif
				print "step",i,"of",nr	
			endfor
		endif
		if (operation==2) // xmcd
			// frame i=([i]-[(i-(+)1])/sum
			// next:  [0-1]/[0+1],-[1-2]/[1+2] .. previous: -[0-1]/[0+1],[1-2]/[1+2]
			ImageTransform/P=(0)/PTYP=0 getPlane $stackStr
			duplicate/o M_ImagePlane wprev,wtmp
			variable thissign=1
			if (mode==2)
				thissign*=-1
			endif
			for (i=0;i<nr;i+=1)
				thissign*=-1
				ImageTransform/P=(i)/PTYP=0 getPlane $stackStr
				duplicate/o M_ImagePlane wtmp
				wtmp=thissign*1000*(wprev-wtmp)/(wprev+wtmp)
				// remove bkg
				if ((bkg==2)&&(exists("M_LayoutMask")))
					ImageRemoveBackground/R=M_layoutMask/O/P=(order) wtmp
				endif
				ImageTransform/P=(i)/PTYP=0/D=wtmp setPlane $stackStr
				duplicate/o M_ImagePlane wprev
				print "step",i,"of",nr			
			endfor
		endif
		killwaves/z wtmp,wprev,M_layoutMask
	endif
End

Function XMCD_toggle()
	// data folder and stack
	String dfStr=SIS_getDataFolderName()
	SetDataFolder root:$(dfStr)
	NVAR layer=root:$(dfStr):layer	
	String stackStr=SIS_getImageStackName()
	wave wstack=$stackStr
	variable nr=dimSize($stackStr,2)
	// display using DC drifts p,q
	variable i=0
	if (nr==2)
		// displays the toggle in a didcated window
		ImageTransform/P=(0)/PTYP=0 getPlane $stackStr
		wave M_imagePlane	
		SIS_imageToFront("Toggle","M_imagePlane")
		do
			ImageTransform/P=(0)/PTYP=0 getPlane $stackStr
			doUpdate
			ImageTransform/P=(1)/PTYP=0 getPlane $stackStr
			doUpdate
			i+=1
		while (i < 100)
		Dowindow/K Toggle
	endif
end

Function XMCD_ImageControls()
	ControlBar 50
	// first line
	Button scalebarButton,pos={5,5},size={90,18},proc=SIS_scalebar,title="scalebar"
	Button prevsubsetButton,pos={100,5},size={90,18},proc=SIS_prevsubset,title="prev subset"
	Button savelayerButton,pos={195,5},size={90,18},proc=SIS_savelayer,title="save image"
	Button killButton,pos={290, 5},size={90,18},proc=SIS_KillStack_ctrl,title="kill"
	// second line
	Button rotateButton,pos={5,25},size={90,18},proc=SIS_rotate,title="rotate"
	Button thresButton,pos={100,25},size={90,18},proc=SIS_thres,title="threshold"
	Button layoutButton,pos={195,25},size={90,18},proc=SIS_imageLayout, title="layout"
	Button removeBkgButton,pos={290,25},size={90,18},proc=SIS_removeBkg,title="removeBkg"
End

